Subject: Re: [PATCH] net: phy: micrel: reconfigure the phy on resume

From: Pavel Machek <[email-masked]>
Date: Thu, 11 Feb 2021 13:17:02 +0100

On Thu 2021-01-14 12:05:21, Heiner Kallweit wrote:
> On 14.01.2021 11:41, [email-masked] wrote:
> > 
> > 
> > On 14.01.2021 12:25, Russell King - ARM Linux admin wrote:
> >>
> >> As I've said, if phylib/PHY driver is not restoring the state of the
> >> PHY on resume from suspend-to-ram, then that's an issue with phylib
> >> and/or the phy driver.
> > 
> > In the patch I proposed in this thread the restoring is done in PHY driver.
> > Do you think I should continue the investigation and check if something
> > should be done from the phylib itself?
> > 
> It was the right move to approach the PM maintainers to clarify whether
> the resume PM callback has to assume that power had been cut off and
> it has to completely reconfigure the device. If they confirm this
> understanding, then:

Power to some devices can be cut during s2ram, yes.

> - the general question remains why there's separate resume and restore
>   callbacks, and what restore is supposed to do that resume doesn't
>   have to do

You'll often have same implementation, yes.

> - it should be sufficient to use mdio_bus_phy_restore also as resume
>   callback (instead of changing each and every PHY driver's resume),
>   because we can expect that somebody cutting off power to the PHY
>   properly suspends the MDIO bus before

If restore works with power cut and power not cut then yes, you should
get away with that.

Best regards,
								Pavel
-- 
http://www.livejournal.com/~pavelmachek